diff -Naur src.pgsql/backend/executor/nodeBitmapHeapscan.c.orig src.bizgres/backend/executor/nodeBitmapHeapscan.c.orig
--- src.pgsql/backend/executor/nodeBitmapHeapscan.c.orig	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/executor/nodeBitmapHeapscan.c.orig	2006-07-17 22:33:18.000000000 -0700
@@ -0,0 +1,568 @@
+/*-------------------------------------------------------------------------
+ *
+ * nodeBitmapHeapscan.c
+ *	  Routines to support bitmapped scans of relations
+ *
+ * NOTE: it is critical that this plan type only be used with MVCC-compliant
+ * snapshots (ie, regular snapshots, not SnapshotNow or one of the other
+ * special snapshots).	The reason is that since index and heap scans are
+ * decoupled, there can be no assurance that the index tuple prompting a
+ * visit to a particular heap TID still exists when the visit is made.
+ * Therefore the tuple might not exist anymore either (which is OK because
+ * heap_fetch will cope) --- but worse, the tuple slot could have been
+ * re-used for a newer tuple.  With an MVCC snapshot the newer tuple is
+ * certain to fail the time qual and so it will not be mistakenly returned.
+ * With SnapshotNow we might return a tuple that doesn't meet the required
+ * index qual conditions.
+ *
+ *
+ * Portions Copyright (c) 1996-2006, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ *
+ * IDENTIFICATION
+ *	  $PostgreSQL: pgsql/src/backend/executor/nodeBitmapHeapscan.c,v 1.13 2006/07/14 14:52:19 momjian Exp $
+ *
+ *-------------------------------------------------------------------------
+ */
+/*
+ * INTERFACE ROUTINES
+ *		ExecBitmapHeapScan			scans a relation using bitmap info
+ *		ExecBitmapHeapNext			workhorse for above
+ *		ExecInitBitmapHeapScan		creates and initializes state info.
+ *		ExecBitmapHeapReScan		prepares to rescan the plan.
+ *		ExecEndBitmapHeapScan		releases all storage.
+ */
+#include "postgres.h"
+
+#include "access/heapam.h"
+#include "executor/execdebug.h"
+#include "executor/nodeBitmapHeapscan.h"
+#include "pgstat.h"
+#include "utils/memutils.h"
+
+
+static TupleTableSlot *BitmapHeapNext(BitmapHeapScanState *node);
+static void bitgetpage(HeapScanDesc scan, TBMIterateResult *tbmres);
+
+
+/* ----------------------------------------------------------------
+ *		BitmapHeapNext
+ *
+ *		Retrieve next tuple from the BitmapHeapScan node's currentRelation
+ * ----------------------------------------------------------------
+ */
+static TupleTableSlot *
+BitmapHeapNext(BitmapHeapScanState *node)
+{
+	EState	   *estate;
+	ExprContext *econtext;
+	HeapScanDesc scan;
+	Index		scanrelid;
+	TIDBitmap  *tbm;
+	TBMIterateResult *tbmres;
+	OffsetNumber targoffset;
+	TupleTableSlot *slot;
+
+	/*
+	 * extract necessary information from index scan node
+	 */
+	estate = node->ss.ps.state;
+	econtext = node->ss.ps.ps_ExprContext;
+	slot = node->ss.ss_ScanTupleSlot;
+	scan = node->ss.ss_currentScanDesc;
+	scanrelid = ((BitmapHeapScan *) node->ss.ps.plan)->scan.scanrelid;
+	tbm = node->tbm;
+	tbmres = node->tbmres;
+
+	/*
+	 * Check if we are evaluating PlanQual for tuple of this relation.
+	 * Additional checking is not good, but no other way for now. We could
+	 * introduce new nodes for this case and handle IndexScan --> NewNode
+	 * switching in Init/ReScan plan...
+	 */
+	if (estate->es_evTuple != NULL &&
+		estate->es_evTuple[scanrelid - 1] != NULL)
+	{
+		if (estate->es_evTupleNull[scanrelid - 1])
+			return ExecClearTuple(slot);
+
+		ExecStoreTuple(estate->es_evTuple[scanrelid - 1],
+					   slot, InvalidBuffer, false);
+
+		/* Does the tuple meet the original qual conditions? */
+		econtext->ecxt_scantuple = slot;
+
+		ResetExprContext(econtext);
+
+		if (!ExecQual(node->bitmapqualorig, econtext, false))
+			ExecClearTuple(slot);		/* would not be returned by scan */
+
+		/* Flag for the next call that no more tuples */
+		estate->es_evTupleNull[scanrelid - 1] = true;
+
+		return slot;
+	}
+
+	/*
+	 * If we haven't yet performed the underlying index scan, do it, and
+	 * prepare the bitmap to be iterated over.
+	 */
+	if (tbm == NULL)
+	{
+		tbm = (TIDBitmap *) MultiExecProcNode(outerPlanState(node));
+
+		if (!tbm || !IsA(tbm, TIDBitmap))
+			elog(ERROR, "unrecognized result from subplan");
+
+		node->tbm = tbm;
+		node->tbmres = tbmres = NULL;
+
+		tbm_begin_iterate(tbm);
+	}
+
+	for (;;)
+	{
+		Page		dp;
+		ItemId		lp;
+
+		/*
+		 * Get next page of results if needed
+		 */
+		if (tbmres == NULL)
+		{
+			node->tbmres = tbmres = tbm_iterate(tbm);
+			if (tbmres == NULL)
+			{
+				/* no more entries in the bitmap */
+				break;
+			}
+
+			/*
+			 * Ignore any claimed entries past what we think is the end of the
+			 * relation.  (This is probably not necessary given that we got at
+			 * least AccessShareLock on the table before performing any of the
+			 * indexscans, but let's be safe.)
+			 */
+			if (tbmres->blockno >= scan->rs_nblocks)
+			{
+				node->tbmres = tbmres = NULL;
+				continue;
+			}
+
+			/*
+			 * Fetch the current heap page and identify candidate tuples.
+			 */
+			bitgetpage(scan, tbmres);
+
+			/*
+			 * Set rs_cindex to first slot to examine
+			 */
+			scan->rs_cindex = 0;
+		}
+		else
+		{
+			/*
+			 * Continuing in previously obtained page; advance rs_cindex
+			 */
+			scan->rs_cindex++;
+		}
+
+		/*
+		 * Out of range?  If so, nothing more to look at on this page
+		 */
+		if (scan->rs_cindex < 0 || scan->rs_cindex >= scan->rs_ntuples)
+		{
+			node->tbmres = tbmres = NULL;
+			continue;
+		}
+
+		/*
+		 * Okay to fetch the tuple
+		 */
+		targoffset = scan->rs_vistuples[scan->rs_cindex];
+		dp = (Page) BufferGetPage(scan->rs_cbuf);
+		lp = PageGetItemId(dp, targoffset);
+		Assert(ItemIdIsUsed(lp));
+
+		scan->rs_ctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
+		scan->rs_ctup.t_len = ItemIdGetLength(lp);
+		ItemPointerSet(&scan->rs_ctup.t_self, tbmres->blockno, targoffset);
+
+		pgstat_count_heap_fetch(&scan->rs_pgstat_info);
+
+		/*
+		 * Set up the result slot to point to this tuple. Note that the
+		 * slot acquires a pin on the buffer.
+		 */
+		ExecStoreTuple(&scan->rs_ctup,
+					   slot,
+					   scan->rs_cbuf,
+					   false);
+
+		/*
+		 * If we are using lossy info, we have to recheck the qual
+		 * conditions at every tuple.
+		 */
+		if (tbmres->ntuples < 0)
+		{
+			econtext->ecxt_scantuple = slot;
+			ResetExprContext(econtext);
+
+			if (!ExecQual(node->bitmapqualorig, econtext, false))
+			{
+				/* Fails recheck, so drop it and loop back for another */
+				ExecClearTuple(slot);
+				continue;
+			}
+		}
+
+		/* OK to return this tuple */
+		return slot;
+	}
+
+	/*
+	 * if we get here it means we are at the end of the scan..
+	 */
+	return ExecClearTuple(slot);
+}
+
+/*
+ * bitgetpage - subroutine for BitmapHeapNext()
+ *
+ * This routine reads and pins the specified page of the relation, then
+ * builds an array indicating which tuples on the page are both potentially
+ * interesting according to the bitmap, and visible according to the snapshot.
+ */
+static void
+bitgetpage(HeapScanDesc scan, TBMIterateResult *tbmres)
+{
+	BlockNumber	page = tbmres->blockno;
+	Buffer		buffer;
+	Snapshot	snapshot;
+	Page		dp;
+	int			ntup;
+	int			curslot;
+	int			minslot;
+	int			maxslot;
+	int			maxoff;
+
+	/*
+	 * Acquire pin on the target heap page, trading in any pin we held before.
+	 */
+	Assert(page < scan->rs_nblocks);
+
+	scan->rs_cbuf = ReleaseAndReadBuffer(scan->rs_cbuf,
+										 scan->rs_rd,
+										 page);
+	buffer = scan->rs_cbuf;
+	snapshot = scan->rs_snapshot;
+
+	/*
+	 * We must hold share lock on the buffer content while examining
+	 * tuple visibility.  Afterwards, however, the tuples we have found
+	 * to be visible are guaranteed good as long as we hold the buffer pin.
+	 */
+	LockBuffer(buffer, BUFFER_LOCK_SHARE);
+
+	dp = (Page) BufferGetPage(buffer);
+	maxoff = PageGetMaxOffsetNumber(dp);
+
+	/*
+	 * Determine how many entries we need to look at on this page. If
+	 * the bitmap is lossy then we need to look at each physical item
+	 * pointer; otherwise we just look through the offsets listed in
+	 * tbmres.
+	 */
+	if (tbmres->ntuples >= 0)
+	{
+		/* non-lossy case */
+		minslot = 0;
+		maxslot = tbmres->ntuples - 1;
+	}
+	else
+	{
+		/* lossy case */
+		minslot = FirstOffsetNumber;
+		maxslot = maxoff;
+	}
+
+	ntup = 0;
+	for (curslot = minslot; curslot <= maxslot; curslot++)
+	{
+		OffsetNumber targoffset;
+		ItemId		lp;
+		HeapTupleData loctup;
+		bool		valid;
+
+		if (tbmres->ntuples >= 0)
+		{
+			/* non-lossy case */
+			targoffset = tbmres->offsets[curslot];
+		}
+		else
+		{
+			/* lossy case */
+			targoffset = (OffsetNumber) curslot;
+		}
+
+		/*
+		 * We'd better check for out-of-range offnum in case of VACUUM since
+		 * the TID was obtained.
+		 */
+		if (targoffset < FirstOffsetNumber || targoffset > maxoff)
+			continue;
+
+		lp = PageGetItemId(dp, targoffset);
+
+		/*
+		 * Must check for deleted tuple.
+		 */
+		if (!ItemIdIsUsed(lp))
+			continue;
+
+		/*
+		 * check time qualification of tuple, remember it if valid
+		 */
+		loctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
+		loctup.t_len = ItemIdGetLength(lp);
+		ItemPointerSet(&(loctup.t_self), page, targoffset);
+
+		valid = HeapTupleSatisfiesVisibility(&loctup, snapshot, buffer);
+		if (valid)
+			scan->rs_vistuples[ntup++] = targoffset;
+	}
+
+	LockBuffer(buffer, BUFFER_LOCK_UNLOCK);
+
+	Assert(ntup <= MaxHeapTuplesPerPage);
+	scan->rs_ntuples = ntup;
+}
+
+/* ----------------------------------------------------------------
+ *		ExecBitmapHeapScan(node)
+ * ----------------------------------------------------------------
+ */
+TupleTableSlot *
+ExecBitmapHeapScan(BitmapHeapScanState *node)
+{
+	/*
+	 * use BitmapHeapNext as access method
+	 */
+	return ExecScan(&node->ss, (ExecScanAccessMtd) BitmapHeapNext);
+}
+
+/* ----------------------------------------------------------------
+ *		ExecBitmapHeapReScan(node)
+ * ----------------------------------------------------------------
+ */
+void
+ExecBitmapHeapReScan(BitmapHeapScanState *node, ExprContext *exprCtxt)
+{
+	EState	   *estate;
+	Index		scanrelid;
+
+	estate = node->ss.ps.state;
+	scanrelid = ((BitmapHeapScan *) node->ss.ps.plan)->scan.scanrelid;
+
+	/*
+	 * If we are being passed an outer tuple, link it into the "regular"
+	 * per-tuple econtext for possible qual eval.
+	 */
+	if (exprCtxt != NULL)
+	{
+		ExprContext *stdecontext;
+
+		stdecontext = node->ss.ps.ps_ExprContext;
+		stdecontext->ecxt_outertuple = exprCtxt->ecxt_outertuple;
+	}
+
+	/* If this is re-scanning of PlanQual ... */
+	if (estate->es_evTuple != NULL &&
+		estate->es_evTuple[scanrelid - 1] != NULL)
+	{
+		estate->es_evTupleNull[scanrelid - 1] = false;
+	}
+
+	/* rescan to release any page pin */
+	heap_rescan(node->ss.ss_currentScanDesc, NULL);
+
+	/* undo bogus "seq scan" count (see notes in ExecInitBitmapHeapScan) */
+	pgstat_discount_heap_scan(&node->ss.ss_currentScanDesc->rs_pgstat_info);
+
+	if (node->tbm)
+		tbm_free(node->tbm);
+	node->tbm = NULL;
+	node->tbmres = NULL;
+
+	/*
+	 * Always rescan the input immediately, to ensure we can pass down any
+	 * outer tuple that might be used in index quals.
+	 */
+	ExecReScan(outerPlanState(node), exprCtxt);
+}
+
+/* ----------------------------------------------------------------
+ *		ExecEndBitmapHeapScan
+ * ----------------------------------------------------------------
+ */
+void
+ExecEndBitmapHeapScan(BitmapHeapScanState *node)
+{
+	Relation	relation;
+	HeapScanDesc scanDesc;
+
+	/*
+	 * extract information from the node
+	 */
+	relation = node->ss.ss_currentRelation;
+	scanDesc = node->ss.ss_currentScanDesc;
+
+	/*
+	 * Free the exprcontext
+	 */
+	ExecFreeExprContext(&node->ss.ps);
+
+	/*
+	 * clear out tuple table slots
+	 */
+	ExecClearTuple(node->ss.ps.ps_ResultTupleSlot);
+	ExecClearTuple(node->ss.ss_ScanTupleSlot);
+
+	/*
+	 * close down subplans
+	 */
+	ExecEndNode(outerPlanState(node));
+
+	/*
+	 * release bitmap if any
+	 */
+	if (node->tbm)
+		tbm_free(node->tbm);
+
+	/*
+	 * close heap scan
+	 */
+	heap_endscan(scanDesc);
+
+	/*
+	 * close the heap relation.
+	 */
+	ExecCloseScanRelation(relation);
+}
+
+/* ----------------------------------------------------------------
+ *		ExecInitBitmapHeapScan
+ *
+ *		Initializes the scan's state information.
+ * ----------------------------------------------------------------
+ */
+BitmapHeapScanState *
+ExecInitBitmapHeapScan(BitmapHeapScan *node, EState *estate, int eflags)
+{
+	BitmapHeapScanState *scanstate;
+	Relation	currentRelation;
+
+	/* check for unsupported flags */
+	Assert(!(eflags & (EXEC_FLAG_BACKWARD | EXEC_FLAG_MARK)));
+
+	/*
+	 * Assert caller didn't ask for an unsafe snapshot --- see comments
+	 * at head of file.
+	 */
+	Assert(IsMVCCSnapshot(estate->es_snapshot));
+
+	/*
+	 * create state structure
+	 */
+	scanstate = makeNode(BitmapHeapScanState);
+	scanstate->ss.ps.plan = (Plan *) node;
+	scanstate->ss.ps.state = estate;
+
+	scanstate->tbm = NULL;
+	scanstate->tbmres = NULL;
+
+	/*
+	 * Miscellaneous initialization
+	 *
+	 * create expression context for node
+	 */
+	ExecAssignExprContext(estate, &scanstate->ss.ps);
+
+	/*
+	 * initialize child expressions
+	 */
+	scanstate->ss.ps.targetlist = (List *)
+		ExecInitExpr((Expr *) node->scan.plan.targetlist,
+					 (PlanState *) scanstate);
+	scanstate->ss.ps.qual = (List *)
+		ExecInitExpr((Expr *) node->scan.plan.qual,
+					 (PlanState *) scanstate);
+	scanstate->bitmapqualorig = (List *)
+		ExecInitExpr((Expr *) node->bitmapqualorig,
+					 (PlanState *) scanstate);
+
+#define BITMAPHEAPSCAN_NSLOTS 2
+
+	/*
+	 * tuple table initialization
+	 */
+	ExecInitResultTupleSlot(estate, &scanstate->ss.ps);
+	ExecInitScanTupleSlot(estate, &scanstate->ss);
+
+	/*
+	 * open the base relation and acquire appropriate lock on it.
+	 */
+	currentRelation = ExecOpenScanRelation(estate, node->scan.scanrelid);
+
+	scanstate->ss.ss_currentRelation = currentRelation;
+
+	/*
+	 * Even though we aren't going to do a conventional seqscan, it is useful
+	 * to create a HeapScanDesc --- this checks the relation size and sets up
+	 * statistical infrastructure for us.
+	 */
+	scanstate->ss.ss_currentScanDesc = heap_beginscan(currentRelation,
+													  estate->es_snapshot,
+													  0,
+													  NULL);
+
+	/*
+	 * One problem is that heap_beginscan counts a "sequential scan" start,
+	 * when we actually aren't doing any such thing.  Reverse out the added
+	 * scan count.	(Eventually we may want to count bitmap scans separately.)
+	 */
+	pgstat_discount_heap_scan(&scanstate->ss.ss_currentScanDesc->rs_pgstat_info);
+
+	/*
+	 * get the scan type from the relation descriptor.
+	 */
+	ExecAssignScanType(&scanstate->ss, RelationGetDescr(currentRelation));
+
+	/*
+	 * Initialize result tuple type and projection info.
+	 */
+	ExecAssignResultTypeFromTL(&scanstate->ss.ps);
+	ExecAssignScanProjectionInfo(&scanstate->ss);
+
+	/*
+	 * initialize child nodes
+	 *
+	 * We do this last because the child nodes will open indexscans on our
+	 * relation's indexes, and we want to be sure we have acquired a lock
+	 * on the relation first.
+	 */
+	outerPlanState(scanstate) = ExecInitNode(outerPlan(node), estate, eflags);
+
+	/*
+	 * all done.
+	 */
+	return scanstate;
+}
+
+int
+ExecCountSlotsBitmapHeapScan(BitmapHeapScan *node)
+{
+	return ExecCountSlotsNode(outerPlan((Plan *) node)) +
+		ExecCountSlotsNode(innerPlan((Plan *) node)) + BITMAPHEAPSCAN_NSLOTS;
+}
diff -Naur src.pgsql/backend/executor/nodeBitmapHeapscan.c.rej src.bizgres/backend/executor/nodeBitmapHeapscan.c.rej
--- src.pgsql/backend/executor/nodeBitmapHeapscan.c.rej	1969-12-31 16:00:00.000000000 -0800
+++ src.bizgres/backend/executor/nodeBitmapHeapscan.c.rej	2006-07-17 22:33:18.000000000 -0700
@@ -0,0 +1,64 @@
+***************
+*** 57,79 ****
+  {
+  	EState	   *estate;
+  	ExprContext *econtext;
+  	HeapScanDesc scan;
+  	Index		scanrelid;
+  	TIDBitmap  *tbm;
+  	TBMIterateResult *tbmres;
+  	OffsetNumber targoffset;
+  	TupleTableSlot *slot;
+  
+  	/*
+  	 * extract necessary information from index scan node
+  	 */
+  	estate = node->ss.ps.state;
+  	econtext = node->ss.ps.ps_ExprContext;
+  	slot = node->ss.ss_ScanTupleSlot;
+  	scan = node->ss.ss_currentScanDesc;
+  	scanrelid = ((BitmapHeapScan *) node->ss.ps.plan)->scan.scanrelid;
+  	tbm = node->tbm;
+  	tbmres = node->tbmres;
+  
+  	/*
+  	 * Check if we are evaluating PlanQual for tuple of this relation.
+--- 57,94 ----
+  {
+  	EState	   *estate;
+  	ExprContext *econtext;
+  	HeapScanDesc scan;
+  	Index		scanrelid;
+  	TIDBitmap  *tbm;
+  	TBMIterateResult *tbmres;
+  	OffsetNumber targoffset;
+  	TupleTableSlot *slot;
+  
++ 	OnDiskBitmapWords *odbm;
++ 	BMIterateResult *odbmres;
++ 	bool inmem = false;
++ 
+  	/*
+  	 * extract necessary information from index scan node
+  	 */
+  	estate = node->ss.ps.state;
+  	econtext = node->ss.ps.ps_ExprContext;
+  	slot = node->ss.ss_ScanTupleSlot;
+  	scan = node->ss.ss_currentScanDesc;
+  	scanrelid = ((BitmapHeapScan *) node->ss.ps.plan)->scan.scanrelid;
+  	tbm = node->tbm;
+  	tbmres = node->tbmres;
++ 	odbm = node->odbm;
++ 	odbmres = node->odbmres;
++ 
++ 	/*
++ 	 * Clear any reference to the previously returned tuple.  The idea here is
++ 	 * to not have the tuple slot be the last holder of a pin on that tuple's
++ 	 * buffer; if it is, we'll need a separate visit to the bufmgr to release
++ 	 * the buffer.	By clearing here, we get to have the release done by
++ 	 * ReleaseAndReadBuffer, below.
++ 	 */
++ 	ExecClearTuple(slot);
+  
+  	/*
+  	 * Check if we are evaluating PlanQual for tuple of this relation.
diff -Naur src.pgsql/backend/executor/nodeBitmapIndexscan.c src.bizgres/backend/executor/nodeBitmapIndexscan.c
--- src.pgsql/backend/executor/nodeBitmapIndexscan.c	2006-07-17 17:05:12.000000000 -0700
+++ src.bizgres/backend/executor/nodeBitmapIndexscan.c	2006-07-17 22:33:18.000000000 -0700
@@ -38,13 +38,17 @@
 MultiExecBitmapIndexScan(BitmapIndexScanState *node)
 {
 #define MAX_TIDS	1024
-	TIDBitmap  *tbm;
+	TIDBitmap  *tbm = NULL;
 	IndexScanDesc scandesc;
+	IndexScanDesc odScanDesc;
 	ItemPointerData tids[MAX_TIDS];
 	int32		ntids;
 	double		nTuples = 0;
 	bool		doscan;
 
+	OnDiskBitmapWords *odbm = NULL;
+	bool	inmem = false;
+
 	/* must provide our own instrumentation support */
 	if (node->ss.ps.instrument)
 		InstrStartNode(node->ss.ps.instrument);
@@ -53,6 +57,7 @@
 	 * extract necessary information from index scan node
 	 */
 	scandesc = node->biss_ScanDesc;
+	odScanDesc = node->odbiss_ScanDesc;
 
 	/*
 	 * If we have runtime keys and they've not already been set up, do it now.
@@ -69,52 +74,76 @@
 	else
 		doscan = true;
 
-	/*
-	 * Prepare the result bitmap.  Normally we just create a new one to pass
-	 * back; however, our parent node is allowed to store a pre-made one into
-	 * node->biss_result, in which case we just OR our tuple IDs into the
-	 * existing bitmap.  (This saves needing explicit UNION steps.)
-	 */
-	if (node->biss_result)
-	{
-		tbm = node->biss_result;
-		node->biss_result = NULL;		/* reset for next time */
-	}
-	else
-	{
-		/* XXX should we use less than work_mem for this? */
-		tbm = tbm_create(work_mem * 1024L);
-	}
+	inmem = ((BitmapIndexScan*)((PlanState*)node)->plan)->inmem;
 
-	/*
-	 * Get TIDs from index and insert into bitmap
-	 */
-	while (doscan)
-	{
-		bool		more = index_getmulti(scandesc, tids, MAX_TIDS, &ntids);
+	if (inmem) {
+
+		node->odbiss_result = NULL;
 
-		if (ntids > 0)
+		/*
+		 * Prepare the result bitmap.  Normally we just create a new one to pass
+		 * back; however, our parent node is allowed to store a pre-made one
+		 * into node->biss_result, in which case we just OR our tuple IDs into
+		 * the existing bitmap.  (This saves needing explicit UNION steps.)
+		 */
+		if (node->biss_result)
 		{
-			tbm_add_tuples(tbm, tids, ntids);
-			nTuples += ntids;
+			tbm = node->biss_result;
+			node->biss_result = NULL;		/* reset for next time */
+		}
+		else
+		{
+			/* XXX should we use less than work_mem for this? */
+			tbm = tbm_create(work_mem * 1024L);
 		}
 
-		CHECK_FOR_INTERRUPTS();
-
-		if (!more)
+		/*
+	 	* Get TIDs from index and insert into bitmap
+	 	*/
+		while (doscan)
 		{
-			doscan = ExecIndexAdvanceArrayKeys(node->biss_ArrayKeys,
-											   node->biss_NumArrayKeys);
-			if (doscan)			/* reset index scan */
-				index_rescan(node->biss_ScanDesc, node->biss_ScanKeys);
+			bool	more = index_getmulti(scandesc, tids, MAX_TIDS, &ntids);
+
+			if (ntids > 0)
+			{
+				tbm_add_tuples(tbm, tids, ntids);
+				nTuples += ntids;
+			}
+
+			CHECK_FOR_INTERRUPTS();
+
+			if (!more)
+			{
+				doscan = ExecIndexAdvanceArrayKeys(node->biss_ArrayKeys,
+												   node->biss_NumArrayKeys);
+				if (doscan)			/* reset index scan */
+					index_rescan(node->biss_ScanDesc, node->biss_ScanKeys);
+			}
 		}
 	}
 
+	else {
+		node->biss_result = NULL;
+
+		if (node->odbiss_result == NULL)
+			node->odbiss_result = odbm_create(BM_MAX_WORDS);
+
+		odbm = node->odbiss_result;
+
+		index_getbitmapwords(odScanDesc, odbm->bitmapWords.maxNumOfWords,
+							&(odbm->bitmapWords.numOfWords), 
+							odbm->bitmapWords.bitmapHeaderWords,
+							odbm->bitmapWords.bitmapContentWords);
+	}
+
 	/* must provide our own instrumentation support */
 	if (node->ss.ps.instrument)
 		InstrStopNode(node->ss.ps.instrument, nTuples);
 
-	return (Node *) tbm;
+	if (tbm != NULL)
+		return (Node *) tbm;
+	else
+		return (Node *) odbm;
 }
 
 /* ----------------------------------------------------------------
@@ -182,12 +211,14 @@
 {
 	Relation	indexRelationDesc;
 	IndexScanDesc indexScanDesc;
+	IndexScanDesc odIndexScanDesc;
 
 	/*
 	 * extract information from the node
 	 */
 	indexRelationDesc = node->biss_RelationDesc;
 	indexScanDesc = node->biss_ScanDesc;
+	odIndexScanDesc = node->odbiss_ScanDesc;
 
 	/*
 	 * Free the exprcontext ... now dead code, see ExecFreeExprContext
@@ -201,6 +232,11 @@
 	 * close the index relation
 	 */
 	index_endscan(indexScanDesc);
+	if (odIndexScanDesc != NULL)
+	{
+		index_endscan(odIndexScanDesc);
+		odIndexScanDesc = NULL;
+	}
 	index_close(indexRelationDesc);
 }
 
@@ -228,6 +264,7 @@
 
 	/* normally we don't make the result bitmap till runtime */
 	indexstate->biss_result = NULL;
+	indexstate->odbiss_result = NULL;
 
 	/*
 	 * Miscellaneous initialization
@@ -319,6 +356,21 @@
 							  indexstate->biss_NumScanKeys,
 							  indexstate->biss_ScanKeys);
 
+	if (node->indexam == BITMAP_AM_OID)
+	{
+		indexstate->odbiss_ScanDesc =
+			index_beginscan_bitmapwords(indexstate->biss_RelationDesc,
+										!relistarget,
+										estate->es_snapshot,
+										indexstate->biss_NumScanKeys,
+										indexstate->biss_ScanKeys);
+		node->inmem = false;
+	} else
+	{
+		indexstate->odbiss_ScanDesc = NULL;
+		node->inmem = true;
+	}
+
 	/*
 	 * all done.
 	 */
diff -Naur src.pgsql/backend/executor/nodeBitmapOr.c src.bizgres/backend/executor/nodeBitmapOr.c
--- src.pgsql/backend/executor/nodeBitmapOr.c	2006-07-17 17:05:12.000000000 -0700
+++ src.bizgres/backend/executor/nodeBitmapOr.c	2006-07-17 22:33:18.000000000 -0700
@@ -49,6 +49,7 @@
 	int			i;
 	ListCell   *l;
 	Plan	   *initNode;
+	bool		inmem = false;
 
 	/* check for unsupported flags */
 	Assert(!(eflags & (EXEC_FLAG_BACKWARD | EXEC_FLAG_MARK)));
@@ -86,9 +87,24 @@
 	{
 		initNode = (Plan *) lfirst(l);
 		bitmapplanstates[i] = ExecInitNode(initNode, estate, eflags);
+		if (!inmem && IsA(initNode, BitmapIndexScan))
+			inmem = (((BitmapIndexScan*)initNode)->indexam != 
+					 BITMAP_AM_OID);
+		else if (!inmem && IsA(initNode, BitmapAnd))
+			inmem = ((BitmapAnd*)initNode)->inmem;
+		else if (!inmem && IsA(initNode, BitmapOr))
+			inmem = ((BitmapOr*)initNode)->inmem;
 		i++;
 	}
 
+	node->inmem = inmem;
+
+	bitmaporstate->odbms = (OnDiskBitmapWords**)
+		palloc0(nplans * sizeof(OnDiskBitmapWords*));
+	for (i=0; i<nplans; i++)
+		bitmaporstate->odbms[i] = odbm_create(BM_MAX_WORDS);
+	bitmaporstate->resultOdbm = NULL;
+
 	return bitmaporstate;
 }
 
@@ -113,7 +129,8 @@
 	PlanState **bitmapplans;
 	int			nplans;
 	int			i;
-	TIDBitmap  *result = NULL;
+	Node		*result = NULL;
+	bool		inmem = ((BitmapOr*)(((PlanState*)node)->plan))->inmem;
 
 	/* must provide our own instrumentation support */
 	if (node->ps.instrument)
@@ -131,46 +148,111 @@
 	for (i = 0; i < nplans; i++)
 	{
 		PlanState  *subnode = bitmapplans[i];
-		TIDBitmap  *subresult;
 
-		/*
-		 * We can special-case BitmapIndexScan children to avoid an explicit
-		 * tbm_union step for each child: just pass down the current result
-		 * bitmap and let the child OR directly into it.
-		 */
-		if (IsA(subnode, BitmapIndexScanState))
-		{
-			if (result == NULL) /* first subplan */
+		/* set the required bitmap type for the subnodes */
+		odbm_set_bitmaptype(subnode->plan, inmem);
+
+		if (inmem) {
+			TIDBitmap  *subresult;
+
+			/*
+			 * We can special-case BitmapIndexScan children to avoid an
+			 * explicit tbm_union step for each child: just pass down the
+		 	* current result bitmap and let the child OR directly into it.
+		 	*/
+			if (IsA(subnode, BitmapIndexScanState))
 			{
-				/* XXX should we use less than work_mem for this? */
-				result = tbm_create(work_mem * 1024L);
+				if (result == NULL)				/* first subplan */
+				{
+					/* XXX should we use less than work_mem for this? */
+					result = (Node*)tbm_create(work_mem * 1024L);
+				}
+
+				((BitmapIndexScanState *) subnode)->biss_result = 
+					(TIDBitmap*)result;
+
+				subresult = (TIDBitmap *) MultiExecProcNode(subnode);
+
+				if (subresult != (TIDBitmap*)result)
+					elog(ERROR, "unrecognized result from subplan");
 			}
+			else
+			{
 
-			((BitmapIndexScanState *) subnode)->biss_result = result;
+				/* standard implementation */
+				subresult = (TIDBitmap *) MultiExecProcNode(subnode);
 
-			subresult = (TIDBitmap *) MultiExecProcNode(subnode);
+				if (!subresult || !IsA(subresult, TIDBitmap))
+					elog(ERROR, "unrecognized result from subplan");
 
-			if (subresult != result)
-				elog(ERROR, "unrecognized result from subplan");
+				if (result == NULL)
+					result = (Node*)subresult;			/* first subplan */
+				else
+				{
+					tbm_union((TIDBitmap*)result, subresult);
+					tbm_free(subresult);
+				}
+			}
 		}
+
 		else
 		{
-			/* standard implementation */
-			subresult = (TIDBitmap *) MultiExecProcNode(subnode);
-
-			if (!subresult || !IsA(subresult, TIDBitmap))
-				elog(ERROR, "unrecognized result from subplan");
+			OnDiskBitmapWords  *subresult;
 
-			if (result == NULL)
-				result = subresult;		/* first subplan */
-			else
+			/* if there is no leftover from previous scan, then
+				read the next list of words. */
+			if (node->odbms[i]->bitmapWords.numOfWords == 0)
 			{
-				tbm_union(result, subresult);
-				tbm_free(subresult);
+				node->odbms[i]->bitmapWords.startNo = 0;
+				odbm_set_child_resultnode(subnode, node->odbms[i]);
+
+				subresult = (OnDiskBitmapWords*) MultiExecProcNode(subnode);
+
+				if (!subresult || !IsA(subresult, OnDiskBitmapWords))
+					elog(ERROR, "unrecognized result from subplan");
+
+				node->odbms[i] = subresult;
 			}
 		}
 	}
 
+	if (!inmem)
+	{
+		BMBatchWords**	batches = (BMBatchWords**)
+			palloc0(nplans* sizeof(BMBatchWords*));
+
+		if (node->resultOdbm == NULL)
+			node->resultOdbm = odbm_create(BM_MAX_WORDS);
+		_bitmap_reset_batchwords(&(node->resultOdbm->bitmapWords));
+
+		for (i=0; i<nplans; i++)
+			batches[i] = &(node->odbms[i]->bitmapWords);
+		_bitmap_union(batches, nplans, &(node->resultOdbm->bitmapWords));
+
+		/* if the number of words in the result is 0, then
+			at least one of subplans contains no words. We
+			want to discard these subplans, and re-calculate
+			the result. */
+		if (node->resultOdbm->bitmapWords.numOfWords == 0)
+		{
+			BMBatchWords** newBatches =
+				palloc0(sizeof(BMBatchWords*)*nplans);
+			uint32	nonempty_nplans = 0;
+
+			for (i=0; i<nplans; i++)
+				if (node->odbms[i]->bitmapWords.numOfWords != 0)
+					newBatches[nonempty_nplans++] =
+						&(node->odbms[i]->bitmapWords);
+
+			_bitmap_reset_batchwords(&(node->resultOdbm->bitmapWords));
+			_bitmap_union(newBatches, nonempty_nplans,
+					   &(node->resultOdbm->bitmapWords));
+			pfree(newBatches);
+		}
+
+		result = (Node*)(node->resultOdbm);
+	}
+
 	/* We could return an empty result set here? */
 	if (result == NULL)
 		elog(ERROR, "BitmapOr doesn't support zero inputs");
@@ -211,6 +293,14 @@
 		if (bitmapplans[i])
 			ExecEndNode(bitmapplans[i]);
 	}
+
+	if (node->odbms != NULL)
+	{
+		for (i=0; i<nplans; i++)
+			if (node->odbms[i] != NULL)
+				odbm_free(node->odbms[i]);
+		pfree(node->odbms);
+	}
 }
 
 void
@@ -229,10 +319,17 @@
 		if (node->ps.chgParam != NULL)
 			UpdateChangedParamSet(subnode, node->ps.chgParam);
 
+		if (node->odbms[i] != NULL)
+		{
+			node->odbms[i]->bitmapWords.startNo = 0;
+			node->odbms[i]->bitmapWords.numOfWords = 0;
+		}
+
 		/*
 		 * Always rescan the inputs immediately, to ensure we can pass down
 		 * any outer tuple that might be used in index quals.
 		 */
 		ExecReScan(subnode, exprCtxt);
 	}
+
 }
diff -Naur src.pgsql/backend/nodes/Makefile src.bizgres/backend/nodes/Makefile
--- src.pgsql/backend/nodes/Makefile	2006-07-17 17:05:16.000000000 -0700
+++ src.bizgres/backend/nodes/Makefile	2006-07-17 22:33:27.000000000 -0700
@@ -14,7 +14,9 @@
 
 OBJS = nodeFuncs.o nodes.o list.o bitmapset.o tidbitmap.o \
        copyfuncs.o equalfuncs.o makefuncs.o \
-       outfuncs.o readfuncs.o print.o read.o params.o value.o
+       outfuncs.o readfuncs.o print.o read.o params.o value.o \
+       ondiskbitmapwords.o
+
 
 all: SUBSYS.o
 
